#ifndef ETHERLIB_ARP_CONNBLOCK_H
#define ETHERLIB_ARP_CONNBLOCK_H

#endif //ETHERLIB_ARP_CONNBLOCK_H

#include <stdint.h>
#include "../../connection_block.h"
#include "../../eth_interface.h"
#include "../packet_parsers/arp_packet.h"

/**
 * Create new ARP connection block.
 * @param intf associated Ethernet interface
 * @param cbFn callback function
 * @return ARP connection block
 */
ConnBlock arp_new_connblock(EthInterface * intf, SieveCallBackFn cb);

/**
 * Send ARP packet.
 * @param connBlock ARP connection block
 * @param props packet data (properties)
 */
void arp_send(const ConnBlock * connBlock, const ArpProps * props);

/**
 * Print ARP connection block report.
 * @param connBlock ARP connblock
 */
void arp_print_report(const ConnBlock* connBlock);